//
//  ViewController.m
//  EmptyPickerView
//
//  Created by TaeHwan Kwon on 1/31/12.
//  Copyright (c) 2012 TaeHwan K. All rights reserved.
//

#import "ViewController.h"
#import "AppDelegate.h"

@implementation ViewController
@synthesize pickerView = _pickerView;
@synthesize appDlg = _appDlg;
@synthesize nowSel = nowSel;
@synthesize keys = _keys;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];
    _appDlg = [[UIApplication sharedApplication] delegate];
    //정렬을 위해 초기화 //keys는 여기서 정렬이 가능하나 values는 여기서 불가능..
    _keys = [[_appDlg.pickerData allKeys] sortedArrayUsingSelector:@selector(compare:)];
}


- (void)viewDidUnload
{
    [self setPickerView:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - pickerView
// returns the number of 'columns' to display.
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {
    return 2;
}

// returns the # of rows in each component..
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component {
    if(component == 0) {
        //0번 component에 해당되는 keys의 전체 카운트를 return한다.
        return [_keys count];
//        return [[_appDlg.pickerData allKeys] count];
    }
    //NSDictionary 에서 해당되는 keys에 해당대는 valueForKey를 얻기위해서 위와 같은 코드를 사용
    return [[_appDlg.pickerData valueForKey:[_keys objectAtIndex:nowSel]] count];
}

#pragma mark - pickerView @optional
- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component {
    NSString *retStr;
    if(component == 0) {
        //0번 component 에 해당하는 keys 이름을 return
//        retStr = [[[_appDlg.pickerData allKeys] sortedArrayUsingSelector:@selector(compare:)]objectAtIndex:row];
        retStr = [_keys objectAtIndex:row];
    } else {
        //1번 component 에 해당하는 value를 구한다음 return
//      //아래와 같이 실시간으로 정렬을 해줄 경우 메모리 릭 발생! NSArray를 사용해서 한번만 정렬하는게 이득임....
        retStr = [[[_appDlg.pickerData valueForKey:[_keys objectAtIndex:nowSel]] sortedArrayUsingSelector:@selector(compare:)] objectAtIndex:row];
    }
    return retStr;
}

- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component {
    if(component == 0) {
        NSLog(@"aaaa");
        
        nowSel = row; //0번째 pickerView의 선택 값을 복사
//        NSLog(@"%d", nowSel);
        [_pickerView reloadComponent:1]; //1번째 pickerView를 초기화
    }
}

@end
